<template>
  <q-chip
    dark
    square
    outline
    :icon="estadoMostrar.icono"
    :color="estadoMostrar.color"
  >
    {{ estadoMostrar.estado }}
  </q-chip>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted, watch } from 'vue';

interface estadoInterface {
  estado: string;
  color: string;
  icono: string;
}

export default defineComponent({
  name: 'ExperienciaEstado',
  props: {
    estado: {
      type: [String, Number],
      required: true,
    },
  },

  setup(props) {
    const estadoMostrar = ref<estadoInterface>({
      estado: 'errro',
      color: 'red',
      icono: 'errro',
    });

    onMounted(() => {
      setEstado(props.estado);
    });

    watch(
      () => props.estado,
      () => {
        setEstado(props.estado);
      }
    );

    function setEstado(estado: string | number) {
      switch (estado) {
        case 1:
        case 'En Curso':
          estadoMostrar.value = {
            estado: 'En Curso',
            color: 'blue-grey',
            icono: 'schedule',
          };
          break;
        case 2:
        case 'Acreditado':
          estadoMostrar.value = {
            estado: 'Acreditado',
            color: 'green',
            icono: 'done',
          };
          break;
        case 3:
        case 'Pendiente TP':
          estadoMostrar.value = {
            estado: 'Pendiente TP',
            color: 'orange',
            icono: 'schedule',
          };
          break;
        case 4:
        case 'Homologa':
          estadoMostrar.value = {
            estado: 'Homologa',
            color: 'green',
            icono: 'done',
          };
          break;
        case 5:
        case 'Recursar':
        case 'No Acreditado':
          estadoMostrar.value = {
            estado: 'No Acreditado',
            color: 'red',
            icono: 'close',
          };
          break;
        case 6:
        case 'Ausente':
          estadoMostrar.value = {
            estado: 'Ausente',
            color: 'red',
            icono: 'close',
          };
          break;
      }
    }

    return {
      estadoMostrar,
    };
  },
});
</script>
